import {createPlugin as $gGrEF$createPlugin, useColorScheme as $gGrEF$useColorScheme} from "sanity";
import {jsx as $gGrEF$jsx, jsxs as $gGrEF$jsxs} from "react/jsx-runtime";
import {useRef as $gGrEF$useRef, useMemo as $gGrEF$useMemo, useImperativeHandle as $gGrEF$useImperativeHandle, useCallback as $gGrEF$useCallback, useEffect as $gGrEF$useEffect} from "react";
import {CodeBlockIcon as $gGrEF$CodeBlockIcon} from "@sanity/icons";
import {set as $gGrEF$set, setIfMissing as $gGrEF$setIfMissing, unset as $gGrEF$unset, MemberField as $gGrEF$MemberField} from "sanity/form";
import {Card as $gGrEF$Card, Select as $gGrEF$Select, Stack as $gGrEF$Stack, Box as $gGrEF$Box} from "@sanity/ui";
import $gGrEF$reactace from "react-ace";
import $gGrEF$styledcomponents, {css as $gGrEF$css} from "styled-components";
import "ace-builds/src-noconflict/mode-batchfile";
import "ace-builds/src-noconflict/mode-csharp";
import "ace-builds/src-noconflict/mode-css";
import "ace-builds/src-noconflict/mode-golang";
import "ace-builds/src-noconflict/mode-html";
import "ace-builds/src-noconflict/mode-java";
import "ace-builds/src-noconflict/mode-javascript";
import "ace-builds/src-noconflict/mode-json";
import "ace-builds/src-noconflict/mode-jsx";
import "ace-builds/src-noconflict/mode-markdown";
import "ace-builds/src-noconflict/mode-mysql";
import "ace-builds/src-noconflict/mode-php";
import "ace-builds/src-noconflict/mode-python";
import "ace-builds/src-noconflict/mode-ruby";
import "ace-builds/src-noconflict/mode-sass";
import "ace-builds/src-noconflict/mode-scss";
import "ace-builds/src-noconflict/mode-sh";
import "ace-builds/src-noconflict/mode-text";
import "ace-builds/src-noconflict/mode-tsx";
import "ace-builds/src-noconflict/mode-typescript";
import "ace-builds/src-noconflict/mode-xml";
import "ace-builds/src-noconflict/mode-yaml";
import "ace-builds/src-noconflict/theme-github";
import "ace-builds/src-noconflict/theme-monokai";
import "ace-builds/src-noconflict/theme-terminal";
import "ace-builds/src-noconflict/theme-tomorrow";












const $b67a72b22aed35f4$export$ac98e174937d3154 = (0, $gGrEF$css)`
  .ace_editor_markers_highlight {
    position: absolute;
    background-color: ${({ theme: theme  })=>theme.sanity.color.solid.primary.enabled.bg};
    opacity: 0.2;
    width: 100% !important;
    border-radius: 0 !important;
  }
`;
function $b67a72b22aed35f4$export$2e2bcd8739ae039(rows) {
    return rows.map((row)=>({
            startRow: Number(row) - 1,
            startCol: 0,
            endRow: Number(row) - 1,
            endCol: Infinity,
            className: "ace_editor_markers_highlight",
            type: "screenLine",
            inFront: true
        }));
}


// Grammar from https://github.com/sanity-io/vscode-sanity
const $78995292efb69282$var$rules = {
    start: [
        {
            include: "#query"
        },
        {
            include: "#value"
        },
        {
            include: "#pair"
        }, 
    ],
    "#query": [
        {
            include: "#nullary-access-operator"
        },
        {
            include: "#arraylike"
        },
        {
            include: "#pipe"
        },
        {
            include: "#sort-order"
        },
        {
            include: "#filter"
        }, 
    ],
    "#variable": [
        {
            token: "variable.other.groq",
            regex: /\$[_A-Za-z][_0-9A-Za-z]*/
        }, 
    ],
    "#keyword": [
        {
            token: "keyword.other.groq",
            regex: /\b(?:asc|desc|in|match)\b/
        }, 
    ],
    "#comparison": [
        {
            token: "keyword.operator.comparison.groq",
            // eslint-disable-next-line no-div-regex
            regex: /==|!=|>=|<=|<!=>|<|>/
        }, 
    ],
    "#operator": [
        {
            token: "keyword.operator.arithmetic.groq",
            regex: /\+|-|\*{1,2}|\/|%/
        }, 
    ],
    "#pipe": [
        {
            token: "keyword.operator.pipe.groq",
            regex: /\|/
        }, 
    ],
    "#logical": [
        {
            token: "keyword.operator.logical.groq",
            regex: /!|&&|\|\|/
        }, 
    ],
    "#reference": [
        {
            token: "keyword.operator.reference.groq",
            regex: /->/
        }, 
    ],
    "#pair": [
        {
            include: "#identifier"
        },
        {
            include: "#value"
        },
        {
            include: "#filter"
        },
        {
            token: "keyword.operator.pair.groq",
            regex: /[=]>/
        }, 
    ],
    "#arraylike": [
        {
            token: "punctuation.definition.bracket.begin.groq",
            regex: /\[/,
            push: [
                {
                    token: [
                        "text",
                        "keyword.operator.descendant.groq"
                    ],
                    regex: /(\])((?:\s*\.)?)/,
                    next: "pop"
                },
                {
                    include: "#range"
                },
                {
                    include: "#filter"
                },
                {
                    include: "#array-values"
                }, 
            ]
        }, 
    ],
    "#array": [
        {
            token: "punctuation.definition.bracket.begin.groq",
            regex: /\[/,
            push: [
                {
                    token: "punctuation.definition.bracket.end.groq",
                    regex: /\]/,
                    next: "pop"
                },
                {
                    include: "#array-values"
                },
                {
                    defaultToken: "meta.structure.array.groq"
                }, 
            ]
        }, 
    ],
    "#range": [
        {
            token: [
                "meta.structure.range.groq",
                "constant.numeric.groq",
                "meta.structure.range.groq",
                "keyword.operator.range.groq",
                "meta.structure.range.groq",
                "constant.numeric.groq",
                "meta.structure.range.groq", 
            ],
            regex: /(\s*)(\d+)(\s*)(\.{2,3})(\s*)(\d+)(\s*)/
        }, 
    ],
    "#spread": [
        {
            token: "punctuation.definition.spread.begin.groq",
            regex: /\.\.\./,
            push: [
                {
                    include: "#array"
                },
                {
                    include: "#function-call"
                },
                {
                    include: "#projection"
                },
                {
                    token: "punctuation.definition.spread.end.groq",
                    regex: /(?=.)/,
                    next: "pop"
                },
                {
                    defaultToken: "meta.structure.spread.groq"
                }, 
            ]
        }, 
    ],
    "#array-values": [
        {
            include: "#value"
        },
        {
            include: "#spread"
        },
        {
            token: "punctuation.separator.array.groq",
            regex: /,/
        },
        {
            token: "invalid.illegal.expected-array-separator.groq",
            regex: /[^\s\]]/
        }, 
    ],
    "#filter": [
        {
            include: "#function-call"
        },
        {
            include: "#keyword"
        },
        {
            include: "#constant"
        },
        {
            include: "#identifier"
        },
        {
            include: "#value"
        },
        {
            include: "#comparison"
        },
        {
            include: "#operator"
        },
        {
            include: "#logical"
        }, 
    ],
    "#comments": [
        {
            token: [
                "punctuation.definition.comment.groq",
                "comment.line.double-slash.js"
            ],
            regex: /(\/\/)(.*$)/
        }, 
    ],
    "#nullary-access-operator": [
        {
            token: "constant.language.groq",
            regex: /[*@^]/
        }, 
    ],
    "#constant": [
        {
            token: "constant.language.groq",
            regex: /\b(?:true|false|null)\b/
        }, 
    ],
    "#number": [
        {
            token: "constant.numeric.groq",
            regex: /-?(?:0|[1-9]\d*)(?:(?:\.\d+)?(?:[eE][+-]?\d+)?)?/
        }, 
    ],
    "#named-projection": [
        {
            include: "#identifier"
        },
        {
            include: "#objectkey"
        },
        {
            include: "#projection"
        }, 
    ],
    "#projection": [
        {
            token: "punctuation.definition.projection.begin.groq",
            regex: /\{/,
            push: [
                {
                    token: "punctuation.definition.projection.end.groq",
                    regex: /\}/,
                    next: "pop"
                },
                {
                    include: "#identifier"
                },
                {
                    include: "#objectkey"
                },
                {
                    include: "#named-projection"
                },
                {
                    include: "#comments"
                },
                {
                    include: "#spread"
                },
                {
                    include: "#pair"
                },
                {
                    token: "punctuation.separator.projection.key-value.groq",
                    regex: /:/,
                    push: [
                        {
                            token: "punctuation.separator.projection.pair.groq",
                            regex: /,|(?=\})/,
                            next: "pop"
                        },
                        {
                            include: "#nullary-access-operator"
                        },
                        {
                            include: "#arraylike"
                        },
                        {
                            include: "#value"
                        },
                        {
                            include: "#spread"
                        },
                        {
                            include: "#identifier"
                        },
                        {
                            include: "#operator"
                        },
                        {
                            include: "#comparison"
                        },
                        {
                            include: "#pair"
                        },
                        {
                            token: "invalid.illegal.expected-projection-separator.groq",
                            regex: /[^\s,]/
                        },
                        {
                            defaultToken: "meta.structure.projection.value.groq"
                        }, 
                    ]
                },
                {
                    token: "invalid.illegal.expected-projection-separator.groq",
                    regex: /[^\s},]/
                },
                {
                    defaultToken: "meta.structure.projection.groq"
                }, 
            ]
        }, 
    ],
    "#string": [
        {
            include: "#single-string"
        },
        {
            include: "#double-string"
        }, 
    ],
    "#double-string": [
        {
            token: "punctuation.definition.string.begin.groq",
            regex: /"/,
            push: [
                {
                    token: "punctuation.definition.string.end.groq",
                    regex: /"/,
                    next: "pop"
                },
                {
                    include: "#stringcontent"
                },
                {
                    defaultToken: "string.quoted.double.groq"
                }, 
            ]
        }, 
    ],
    "#single-string": [
        {
            token: "punctuation.definition.string.single.begin.groq",
            regex: /'/,
            push: [
                {
                    token: "punctuation.definition.string.single.end.groq",
                    regex: /'/,
                    next: "pop"
                },
                {
                    include: "#stringcontent"
                },
                {
                    defaultToken: "string.quoted.single.groq"
                }, 
            ]
        }, 
    ],
    "#objectkey": [
        {
            include: "#string"
        }, 
    ],
    "#stringcontent": [
        {
            token: "constant.character.escape.groq",
            regex: /\\(?:["\\/bfnrt]|u[0-9a-fA-F]{4})/
        },
        {
            token: "invalid.illegal.unrecognized-string-escape.groq",
            regex: /\\./
        }, 
    ],
    "#sort-pair": [
        {
            token: [
                "variable.other.readwrite.groq",
                "text",
                "keyword.other.groq"
            ],
            regex: /([_A-Za-z][_0-9A-Za-z]*)(?:(\s*)(asc|desc))?/
        },
        {
            token: [
                "constant.language.groq",
                "punctuation.definition.bracket.begin.groq"
            ],
            regex: /(@)(\[)/,
            push: [
                {
                    token: [
                        "punctuation.definition.bracket.begin.groq",
                        "text",
                        "keyword.other.groq"
                    ],
                    regex: /(\])(?:(\s*)(asc|desc))?/,
                    next: "pop"
                },
                {
                    include: "#string"
                }, 
            ]
        }, 
    ],
    "#sort-order": [
        {
            token: "support.function.sortorder.begin.groq",
            regex: /\border\s*\(/,
            push: [
                {
                    token: "support.function.sortorder.end.groq",
                    regex: /\)/,
                    next: "pop"
                },
                {
                    include: "#sort-pair"
                },
                {
                    token: "punctuation.separator.array.groq",
                    regex: /,/
                },
                {
                    token: "invalid.illegal.expected-sort-separator.groq",
                    regex: /[^\s\]]/
                },
                {
                    defaultToken: "support.function.sortorder.groq"
                }, 
            ]
        }, 
    ],
    "#function-call": [
        {
            include: "#function-var-arg"
        },
        {
            include: "#function-single-arg"
        },
        {
            include: "#function-round"
        }, 
    ],
    "#function-var-arg": [
        {
            token: "support.function.vararg.begin.groq",
            regex: /\b(?:coalesce|select)\s*\(/,
            push: [
                {
                    token: "support.function.vararg.end.groq",
                    regex: /\)/,
                    next: "pop"
                },
                {
                    include: "#value"
                },
                {
                    include: "#identifier"
                },
                {
                    include: "#filter"
                },
                {
                    include: "#pair"
                },
                {
                    token: "punctuation.separator.array.groq",
                    regex: /,/
                },
                {
                    defaultToken: "support.function.vararg.groq"
                }, 
            ]
        }, 
    ],
    "#function-single-arg": [
        {
            token: "support.function.singlearg.begin.groq",
            regex: /\b(?:count|defined|length|path|references)\s*\(/,
            push: [
                {
                    token: "support.function.singlearg.end.groq",
                    regex: /\)/,
                    next: "pop"
                },
                {
                    include: "#query"
                },
                {
                    include: "#identifier"
                },
                {
                    include: "#value"
                },
                {
                    include: "#pair"
                },
                {
                    defaultToken: "support.function.singlearg.groq"
                }, 
            ]
        }, 
    ],
    "#identifier": [
        {
            token: [
                "variable.other.readwrite.groq",
                "text",
                "punctuation.definition.block.js",
                "text",
                "keyword.operator.reference.groq", 
            ],
            regex: /([_A-Za-z][_0-9A-Za-z]*)(\s*)((?:\[\s*\])?)(\s*)(->)/
        },
        {
            token: [
                "variable.other.readwrite.groq",
                "constant.language.groq",
                "text",
                "punctuation.definition.block.js",
                "text",
                "keyword.operator.descendant.groq", 
            ],
            regex: /(?:([_A-Za-z][_0-9A-Za-z]*)|([@^]))(\s*)((?:\[\s*\])?)(\s*)(\.)/
        },
        {
            token: "variable.other.readwrite.groq",
            regex: /[_A-Za-z][_0-9A-Za-z]*/
        }, 
    ],
    "#value": [
        {
            include: "#constant"
        },
        {
            include: "#number"
        },
        {
            include: "#string"
        },
        {
            include: "#array"
        },
        {
            include: "#variable"
        },
        {
            include: "#projection"
        },
        {
            include: "#comments"
        },
        {
            include: "#function-call"
        }, 
    ]
};
ace.define("ace/mode/groq_highlight_rules", [
    "require",
    "exports",
    "module",
    "ace/lib/oop",
    "ace/mode/text_highlight_rules"
], (acequire, exports, _module)=>{
    const oop = acequire("../lib/oop");
    const TextHighlightRules = acequire("./text_highlight_rules").TextHighlightRules;
    const GroqHighlightRules = function() {
        /* eslint-disable @typescript-eslint/ban-ts-comment */ // @ts-ignore
        this.$rules = $78995292efb69282$var$rules;
        // @ts-ignore
        this.normalizeRules();
    /* eslint-enable @typescript-eslint/ban-ts-comment */ };
    oop.inherits(GroqHighlightRules, TextHighlightRules);
    exports.GroqHighlightRules = GroqHighlightRules;
});
ace.define("ace/mode/groq", [
    "require",
    "exports",
    "module",
    "ace/lib/oop",
    "ace/mode/text",
    "ace/tokenizer",
    "ace/mode/groq_highlight_rules",
    "ace/mode/folding/cstyle", 
], (acequire, exports, _module)=>{
    // eslint-disable-next-line strict
    "use strict";
    const oop = acequire("../lib/oop");
    const TextMode = acequire("./text").Mode;
    const Tokenizer = acequire("../tokenizer").Tokenizer;
    const GroqHighlightRules = acequire("./groq_highlight_rules").GroqHighlightRules;
    const FoldMode = acequire("./folding/cstyle").FoldMode;
    const Mode = function() {
        /* eslint-disable @typescript-eslint/ban-ts-comment */ const highlighter = new GroqHighlightRules();
        // @ts-ignore
        this.foldingRules = new FoldMode();
        // @ts-ignore
        this.$tokenizer = new Tokenizer(highlighter.getRules());
        // @ts-ignore
        this.$keywordList = highlighter.$keywordList;
    /* eslint-enable @typescript-eslint/ban-ts-comment */ };
    oop.inherits(Mode, TextMode);
    (function() {
        /* eslint-disable @typescript-eslint/ban-ts-comment */ // @ts-ignore
        this.lineCommentStart = "'";
    /* eslint-enable @typescript-eslint/ban-ts-comment */ }).call(Mode.prototype);
    exports.Mode = Mode;
});






























const $513a6452b1f07fd5$export$7c77c3a9bb93870d = [
    {
        title: "Batch file",
        value: "batchfile"
    },
    {
        title: "C#",
        value: "csharp"
    },
    {
        title: "CSS",
        value: "css"
    },
    {
        title: "Go",
        value: "golang"
    },
    {
        title: "GROQ",
        value: "groq"
    },
    {
        title: "HTML",
        value: "html"
    },
    {
        title: "Java",
        value: "java"
    },
    {
        title: "JavaScript",
        value: "javascript"
    },
    {
        title: "JSON",
        value: "json"
    },
    {
        title: "JSX",
        value: "jsx"
    },
    {
        title: "Markdown",
        value: "markdown"
    },
    {
        title: "MySQL",
        value: "mysql"
    },
    {
        title: "PHP",
        value: "php"
    },
    {
        title: "Plain text",
        value: "text"
    },
    {
        title: "Python",
        value: "python"
    },
    {
        title: "Ruby",
        value: "ruby"
    },
    {
        title: "SASS",
        value: "sass"
    },
    {
        title: "SCSS",
        value: "scss"
    },
    {
        title: "sh",
        value: "sh"
    },
    {
        title: "TSX",
        value: "tsx"
    },
    {
        title: "TypeScript",
        value: "typescript"
    },
    {
        title: "XML",
        value: "xml"
    },
    {
        title: "YAML",
        value: "yaml"
    }, 
];
const $513a6452b1f07fd5$export$eee7619b712ad3ea = {
    js: "javascript"
};
const $513a6452b1f07fd5$export$b524d09a6fa74640 = [
    "github",
    "monokai",
    "terminal",
    "tomorrow"
];
const $513a6452b1f07fd5$export$2faeed762aac6741 = "tomorrow";
const $513a6452b1f07fd5$export$5932020c8339f18b = "monokai";
const $513a6452b1f07fd5$export$1d910bb34606e145 = {
    useSoftTabs: true,
    navigateWithinSoftTabs: true
};
const $513a6452b1f07fd5$export$24aa1be5d8c3cd08 = {
    $blockScrolling: true
};
const $513a6452b1f07fd5$export$ed1ca6559dfc13f7 = [
    "language"
];
const $513a6452b1f07fd5$export$e1d3cf7d57c23d0f = [
    "code"
];
const $513a6452b1f07fd5$export$4f74600301fa25db = [
    "filename"
];



const $a1d4bfd2763f687f$var$EditorContainer = (0, $gGrEF$styledcomponents)((0, $gGrEF$Card))`
  position: relative;
  box-sizing: border-box;
  overflow: hidden;
  z-index: 0;

  .ace_editor {
    font-family: ${({ theme: theme  })=>theme.sanity.fonts.code.family};
    font-size: ${({ theme: theme  })=>theme.sanity.fonts.code.sizes[1]};
    line-height: inherit;
  }

  ${(0, $b67a72b22aed35f4$export$ac98e174937d3154)}

  &:not([disabled]):not([readonly]) {
    &:focus,
    &:focus-within {
      box-shadow: 0 0 0 2px ${({ theme: theme  })=>theme.sanity.color.base.focusRing};
      background-color: ${({ theme: theme  })=>theme.sanity.color.base.bg};
      border-color: ${({ theme: theme  })=>theme.sanity.color.base.focusRing};
    }
  }
`;
// Returns a string with the mode name if supported (because aliases), otherwise false
function $a1d4bfd2763f687f$var$isSupportedLanguage(mode) {
    const alias = (0, $513a6452b1f07fd5$export$eee7619b712ad3ea)[mode];
    if (alias) return alias;
    const isSupported = (0, $513a6452b1f07fd5$export$7c77c3a9bb93870d).find((lang)=>lang.value === mode);
    if (isSupported) return mode;
    return false;
}
function $a1d4bfd2763f687f$export$20d4ca75cb144ab0(props) {
    const { focusRef: focusRef , members: members , onBlur: onBlur , onChange: onChange , onFocusPath: onFocusPath , readOnly: readOnly , renderField: renderField , renderInput: renderInput , renderItem: renderItem , schemaType: type , value: value ,  } = props;
    const aceEditorRef = (0, $gGrEF$useRef)();
    const fieldMembers = (0, $gGrEF$useMemo)(()=>members.filter((member)=>member.kind === "field"), [
        members
    ]);
    const languageFieldMember = fieldMembers.find((member)=>member.name === "language");
    const filenameMember = fieldMembers.find((member)=>member.name === "filename");
    const codeFieldMember = fieldMembers.find((member)=>member.name === "code");
    (0, $gGrEF$useImperativeHandle)(focusRef, ()=>({
            focus: ()=>{
                aceEditorRef?.current?.editor?.focus();
            }
        }));
    const handleCodeFocus = (0, $gGrEF$useCallback)(()=>{
        onFocusPath((0, $513a6452b1f07fd5$export$e1d3cf7d57c23d0f));
    }, [
        onFocusPath
    ]);
    const { scheme: scheme  } = (0, $gGrEF$useColorScheme)();
    const theme = (0, $gGrEF$useMemo)(()=>{
        const isLight = scheme === "light";
        const preferredTheme = isLight ? type.options?.theme : type.options?.darkTheme;
        const defaultTheme = isLight ? (0, $513a6452b1f07fd5$export$2faeed762aac6741) : (0, $513a6452b1f07fd5$export$5932020c8339f18b);
        return preferredTheme && (0, $513a6452b1f07fd5$export$b524d09a6fa74640).find((t)=>t === preferredTheme) ? preferredTheme : defaultTheme;
    }, [
        type,
        scheme
    ]);
    const handleToggleSelectLine = (0, $gGrEF$useCallback)((lineNumber)=>{
        const editorSession = aceEditorRef.current?.editor?.getSession();
        const backgroundMarkers = editorSession?.getMarkers(true);
        const currentHighlightedLines = Object.keys(backgroundMarkers).filter((key)=>backgroundMarkers[key].type === "screenLine").map((key)=>backgroundMarkers[key].range.start.row);
        const currentIndex = currentHighlightedLines.indexOf(lineNumber);
        if (currentIndex > -1) // toggle remove
        currentHighlightedLines.splice(currentIndex, 1);
        else {
            // toggle add
            currentHighlightedLines.push(lineNumber);
            currentHighlightedLines.sort();
        }
        onChange((0, $gGrEF$set)(currentHighlightedLines.map((line)=>// ace starts at line (row) 0, but we store it starting at line 1
            line + 1), [
            "highlightedLines"
        ]));
    }, [
        aceEditorRef,
        onChange
    ]);
    const handleGutterMouseDown = (0, $gGrEF$useCallback)((event)=>{
        const target = event.domEvent.target;
        if (target.classList.contains("ace_gutter-cell")) {
            const row = event.getDocumentPosition().row;
            handleToggleSelectLine(row);
        }
    }, [
        handleToggleSelectLine
    ]);
    (0, $gGrEF$useEffect)(()=>{
        const editor = aceEditorRef?.current?.editor;
        return ()=>{
            editor?.session?.removeListener("guttermousedown", handleGutterMouseDown);
        };
    }, [
        aceEditorRef,
        handleGutterMouseDown
    ]);
    const handleEditorLoad = (0, $gGrEF$useCallback)((editor)=>{
        editor?.on("guttermousedown", handleGutterMouseDown);
    }, [
        handleGutterMouseDown
    ]);
    const getLanguageAlternatives = (0, $gGrEF$useCallback)(()=>{
        const languageAlternatives = type.options?.languageAlternatives;
        if (!languageAlternatives) return 0, $513a6452b1f07fd5$export$7c77c3a9bb93870d;
        if (!Array.isArray(languageAlternatives)) throw new Error(`'options.languageAlternatives' should be an array, got ${typeof languageAlternatives}`);
        return languageAlternatives.reduce((acc, { title: title , value: val , mode: mode  })=>{
            const alias = (0, $513a6452b1f07fd5$export$eee7619b712ad3ea)[val];
            if (alias) {
                // eslint-disable-next-line no-console
                console.warn(`'options.languageAlternatives' lists a language with value "%s", which is an alias of "%s" - please replace the value to read "%s"`, val, alias, alias);
                return acc.concat({
                    title: title,
                    value: alias,
                    mode: mode
                });
            }
            if (!mode && !(0, $513a6452b1f07fd5$export$7c77c3a9bb93870d).find((lang)=>lang.value === val)) // eslint-disable-next-line no-console
            console.warn(`'options.languageAlternatives' lists a language which is not supported: "%s", syntax highlighting will be disabled.`, val);
            return acc.concat({
                title: title,
                value: val,
                mode: mode
            });
        }, []);
    }, [
        type
    ]);
    const handleCodeChange = (0, $gGrEF$useCallback)((code)=>{
        const path = (0, $513a6452b1f07fd5$export$e1d3cf7d57c23d0f);
        const fixedLanguage = type.options?.language;
        onChange([
            (0, $gGrEF$setIfMissing)({
                _type: type.name,
                language: fixedLanguage
            }),
            code ? (0, $gGrEF$set)(code, path) : (0, $gGrEF$unset)(path), 
        ]);
    }, [
        onChange,
        type
    ]);
    const languages = getLanguageAlternatives().slice();
    const fixedLanguage1 = type.options?.language;
    const language = value?.language || fixedLanguage1;
    // the language config from the schema
    const configured = languages.find((entry)=>entry.value === language);
    // is the language officially supported (e.g. we import the mode by default)
    const supported = language && $a1d4bfd2763f687f$var$isSupportedLanguage(language);
    const mode1 = configured?.mode || (supported ? language : "text");
    const renderLanguageInput = (0, $gGrEF$useCallback)((inputProps)=>{
        return /*#__PURE__*/ (0, $gGrEF$jsx)((0, $gGrEF$Select), {
            ...inputProps,
            onChange: (e)=>{
                const newValue = e.currentTarget.value;
                inputProps.onChange(newValue ? (0, $gGrEF$set)(newValue) : (0, $gGrEF$unset)());
            },
            children: languages.map((lang)=>/*#__PURE__*/ (0, $gGrEF$jsx)("option", {
                    value: lang.value,
                    children: lang.title
                }, lang.value))
        });
    }, [
        languages
    ]);
    const renderCodeInput = (0, $gGrEF$useCallback)((inputProps)=>{
        return /*#__PURE__*/ (0, $gGrEF$jsx)($a1d4bfd2763f687f$var$EditorContainer, {
            radius: 1,
            shadow: 1,
            readOnly: readOnly,
            children: /*#__PURE__*/ (0, $gGrEF$jsx)((0, $gGrEF$reactace), {
                ref: aceEditorRef,
                mode: mode1,
                theme: theme,
                width: "100%",
                onChange: handleCodeChange,
                name: inputProps.id,
                value: inputProps.value,
                markers: value && value.highlightedLines ? (0, $b67a72b22aed35f4$export$2e2bcd8739ae039)(value.highlightedLines) : undefined,
                onLoad: handleEditorLoad,
                readOnly: readOnly,
                tabSize: 2,
                wrapEnabled: true,
                setOptions: (0, $513a6452b1f07fd5$export$1d910bb34606e145),
                editorProps: (0, $513a6452b1f07fd5$export$24aa1be5d8c3cd08),
                onFocus: handleCodeFocus,
                onBlur: onBlur
            })
        });
    }, [
        theme,
        handleCodeChange,
        handleCodeFocus,
        handleEditorLoad,
        mode1,
        onBlur,
        readOnly,
        value
    ]);
    return /*#__PURE__*/ (0, $gGrEF$jsxs)((0, $gGrEF$Stack), {
        space: 4,
        children: [
            languageFieldMember && /*#__PURE__*/ (0, $gGrEF$jsx)((0, $gGrEF$MemberField), {
                member: languageFieldMember,
                renderItem: renderItem,
                renderField: renderField,
                renderInput: renderLanguageInput
            }),
            type.options?.withFilename && filenameMember && /*#__PURE__*/ (0, $gGrEF$jsx)((0, $gGrEF$MemberField), {
                member: filenameMember,
                renderItem: renderItem,
                renderField: renderField,
                renderInput: renderInput
            }),
            codeFieldMember && /*#__PURE__*/ (0, $gGrEF$jsx)((0, $gGrEF$MemberField), {
                member: codeFieldMember,
                renderInput: renderCodeInput,
                renderItem: renderItem,
                renderField: renderField
            })
        ]
    });
}










const $0fe3fd43374a598c$var$PreviewContainer = (0, $gGrEF$styledcomponents)((0, $gGrEF$Box))`
  position: relative;
`;
const $0fe3fd43374a598c$var$PreviewInner = (0, $gGrEF$styledcomponents)((0, $gGrEF$Box))`
  background-color: #272822;

  .ace_editor {
    box-sizing: border-box;
    cursor: default;
    pointer-events: none;
  }

  .ace_content {
    box-sizing: border-box;
    overflow: hidden;
  }
`;
function $0fe3fd43374a598c$export$2e2bcd8739ae039(props) {
    const aceEditorRef = (0, $gGrEF$useRef)();
    (0, $gGrEF$useEffect)(()=>{
        if (!aceEditorRef?.current) return;
        const editor = aceEditorRef.current?.editor;
        if (editor) {
            // Avoid cursor and focus tracking by Ace
            editor.renderer.$cursorLayer.element.style.opacity = 0;
            editor.textInput.getElement().disabled = true;
        }
    }, []);
    const handleEditorChange = (0, $gGrEF$useCallback)(()=>{
    // do nothing when the editor changes
    }, []);
    const { value: value , type: type  } = props;
    const fixedLanguage = type?.options?.language;
    const mode = value?.language || fixedLanguage || "text";
    return /*#__PURE__*/ (0, $gGrEF$jsx)($0fe3fd43374a598c$var$PreviewContainer, {
        children: /*#__PURE__*/ (0, $gGrEF$jsx)($0fe3fd43374a598c$var$PreviewInner, {
            padding: 4,
            children: /*#__PURE__*/ (0, $gGrEF$jsx)((0, $gGrEF$reactace), {
                ref: aceEditorRef,
                focus: false,
                mode: mode,
                theme: "monokai",
                width: "100%",
                onChange: handleEditorChange,
                maxLines: 200,
                readOnly: true,
                wrapEnabled: true,
                showPrintMargin: false,
                highlightActiveLine: false,
                cursorStart: -1,
                value: value && value.code || "",
                markers: value && value.highlightedLines ? (0, $b67a72b22aed35f4$export$2e2bcd8739ae039)(value.highlightedLines) : undefined,
                tabSize: 2,
                showGutter: false,
                setOptions: (0, $513a6452b1f07fd5$export$1d910bb34606e145),
                editorProps: (0, $513a6452b1f07fd5$export$24aa1be5d8c3cd08)
            })
        })
    });
}




function $a7f1af2d8cb566bf$export$a854ab43349813f2(language) {
    if (language === "jsx") return /*#__PURE__*/ (0, $gGrEF$jsx)("svg", {
        xmlns: "http://www.w3.org/2000/svg",
        viewBox: "0 0 128 128",
        children: /*#__PURE__*/ (0, $gGrEF$jsxs)("g", {
            fill: "#61DAFB",
            children: [
                /*#__PURE__*/ (0, $gGrEF$jsx)("circle", {
                    cx: "64",
                    cy: "64",
                    r: "11.4"
                }),
                /*#__PURE__*/ (0, $gGrEF$jsx)("path", {
                    d: "M107.3 45.2c-2.2-.8-4.5-1.6-6.9-2.3.6-2.4 1.1-4.8 1.5-7.1 2.1-13.2-.2-22.5-6.6-26.1-1.9-1.1-4-1.6-6.4-1.6-7 0-15.9 5.2-24.9 13.9-9-8.7-17.9-13.9-24.9-13.9-2.4 0-4.5.5-6.4 1.6-6.4 3.7-8.7 13-6.6 26.1.4 2.3.9 4.7 1.5 7.1-2.4.7-4.7 1.4-6.9 2.3C8.2 50 1.4 56.6 1.4 64s6.9 14 19.3 18.8c2.2.8 4.5 1.6 6.9 2.3-.6 2.4-1.1 4.8-1.5 7.1-2.1 13.2.2 22.5 6.6 26.1 1.9 1.1 4 1.6 6.4 1.6 7.1 0 16-5.2 24.9-13.9 9 8.7 17.9 13.9 24.9 13.9 2.4 0 4.5-.5 6.4-1.6 6.4-3.7 8.7-13 6.6-26.1-.4-2.3-.9-4.7-1.5-7.1 2.4-.7 4.7-1.4 6.9-2.3 12.5-4.8 19.3-11.4 19.3-18.8s-6.8-14-19.3-18.8zM92.5 14.7c4.1 2.4 5.5 9.8 3.8 20.3-.3 2.1-.8 4.3-1.4 6.6-5.2-1.2-10.7-2-16.5-2.5-3.4-4.8-6.9-9.1-10.4-13 7.4-7.3 14.9-12.3 21-12.3 1.3 0 2.5.3 3.5.9zM81.3 74c-1.8 3.2-3.9 6.4-6.1 9.6-3.7.3-7.4.4-11.2.4-3.9 0-7.6-.1-11.2-.4-2.2-3.2-4.2-6.4-6-9.6-1.9-3.3-3.7-6.7-5.3-10 1.6-3.3 3.4-6.7 5.3-10 1.8-3.2 3.9-6.4 6.1-9.6 3.7-.3 7.4-.4 11.2-.4 3.9 0 7.6.1 11.2.4 2.2 3.2 4.2 6.4 6 9.6 1.9 3.3 3.7 6.7 5.3 10-1.7 3.3-3.4 6.6-5.3 10zm8.3-3.3c1.5 3.5 2.7 6.9 3.8 10.3-3.4.8-7 1.4-10.8 1.9 1.2-1.9 2.5-3.9 3.6-6 1.2-2.1 2.3-4.2 3.4-6.2zM64 97.8c-2.4-2.6-4.7-5.4-6.9-8.3 2.3.1 4.6.2 6.9.2 2.3 0 4.6-.1 6.9-.2-2.2 2.9-4.5 5.7-6.9 8.3zm-18.6-15c-3.8-.5-7.4-1.1-10.8-1.9 1.1-3.3 2.3-6.8 3.8-10.3 1.1 2 2.2 4.1 3.4 6.1 1.2 2.2 2.4 4.1 3.6 6.1zm-7-25.5c-1.5-3.5-2.7-6.9-3.8-10.3 3.4-.8 7-1.4 10.8-1.9-1.2 1.9-2.5 3.9-3.6 6-1.2 2.1-2.3 4.2-3.4 6.2zM64 30.2c2.4 2.6 4.7 5.4 6.9 8.3-2.3-.1-4.6-.2-6.9-.2-2.3 0-4.6.1-6.9.2 2.2-2.9 4.5-5.7 6.9-8.3zm22.2 21l-3.6-6c3.8.5 7.4 1.1 10.8 1.9-1.1 3.3-2.3 6.8-3.8 10.3-1.1-2.1-2.2-4.2-3.4-6.2zM31.7 35c-1.7-10.5-.3-17.9 3.8-20.3 1-.6 2.2-.9 3.5-.9 6 0 13.5 4.9 21 12.3-3.5 3.8-7 8.2-10.4 13-5.8.5-11.3 1.4-16.5 2.5-.6-2.3-1-4.5-1.4-6.6zM7 64c0-4.7 5.7-9.7 15.7-13.4 2-.8 4.2-1.5 6.4-2.1 1.6 5 3.6 10.3 6 15.6-2.4 5.3-4.5 10.5-6 15.5C15.3 75.6 7 69.6 7 64zm28.5 49.3c-4.1-2.4-5.5-9.8-3.8-20.3.3-2.1.8-4.3 1.4-6.6 5.2 1.2 10.7 2 16.5 2.5 3.4 4.8 6.9 9.1 10.4 13-7.4 7.3-14.9 12.3-21 12.3-1.3 0-2.5-.3-3.5-.9zM96.3 93c1.7 10.5.3 17.9-3.8 20.3-1 .6-2.2.9-3.5.9-6 0-13.5-4.9-21-12.3 3.5-3.8 7-8.2 10.4-13 5.8-.5 11.3-1.4 16.5-2.5.6 2.3 1 4.5 1.4 6.6zm9-15.6c-2 .8-4.2 1.5-6.4 2.1-1.6-5-3.6-10.3-6-15.6 2.4-5.3 4.5-10.5 6-15.5 13.8 4 22.1 10 22.1 15.6 0 4.7-5.8 9.7-15.7 13.4z"
                })
            ]
        })
    });
    if (language === "javascript") return /*#__PURE__*/ (0, $gGrEF$jsxs)("svg", {
        xmlns: "http://www.w3.org/2000/svg",
        viewBox: "0 0 128 128",
        children: [
            /*#__PURE__*/ (0, $gGrEF$jsx)("path", {
                fill: "#F0DB4F",
                d: "M1.408 1.408h125.184v125.185H1.408z"
            }),
            /*#__PURE__*/ (0, $gGrEF$jsx)("path", {
                fill: "#323330",
                d: "M116.347 96.736c-.917-5.711-4.641-10.508-15.672-14.981-3.832-1.761-8.104-3.022-9.377-5.926-.452-1.69-.512-2.642-.226-3.665.821-3.32 4.784-4.355 7.925-3.403 2.023.678 3.938 2.237 5.093 4.724 5.402-3.498 5.391-3.475 9.163-5.879-1.381-2.141-2.118-3.129-3.022-4.045-3.249-3.629-7.676-5.498-14.756-5.355l-3.688.477c-3.534.893-6.902 2.748-8.877 5.235-5.926 6.724-4.236 18.492 2.975 23.335 7.104 5.332 17.54 6.545 18.873 11.531 1.297 6.104-4.486 8.08-10.234 7.378-4.236-.881-6.592-3.034-9.139-6.949-4.688 2.713-4.688 2.713-9.508 5.485 1.143 2.499 2.344 3.63 4.26 5.795 9.068 9.198 31.76 8.746 35.83-5.176.165-.478 1.261-3.666.38-8.581zM69.462 58.943H57.753l-.048 30.272c0 6.438.333 12.34-.714 14.149-1.713 3.558-6.152 3.117-8.175 2.427-2.059-1.012-3.106-2.451-4.319-4.485-.333-.584-.583-1.036-.667-1.071l-9.52 5.83c1.583 3.249 3.915 6.069 6.902 7.901 4.462 2.678 10.459 3.499 16.731 2.059 4.082-1.189 7.604-3.652 9.448-7.401 2.666-4.915 2.094-10.864 2.07-17.444.06-10.735.001-21.468.001-32.237z"
            })
        ]
    });
    if (language === "php") return /*#__PURE__*/ (0, $gGrEF$jsx)("svg", {
        xmlns: "http://www.w3.org/2000/svg",
        viewBox: "0 0 800 400",
        children: /*#__PURE__*/ (0, $gGrEF$jsx)("g", {
            transform: "translate(-44.632 -141.55)",
            children: /*#__PURE__*/ (0, $gGrEF$jsxs)("g", {
                transform: "matrix(8.3528 0 0 8.3119 -727.13 -3759.5)",
                children: [
                    /*#__PURE__*/ (0, $gGrEF$jsx)("path", {
                        d: "m99.974 479.48h14.204c4.1693 0.0354 7.1903 1.2367 9.063 3.604 1.8726 2.3674 2.491 5.6004 1.855 9.699-0.24737 1.8727-0.79504 3.71-1.643 5.512-0.8127 1.802-1.9434 3.4273-3.392 4.876-1.7667 1.8373-3.657 3.0033-5.671 3.498-2.014 0.49467-4.0987 0.742-6.254 0.742h-6.36l-2.014 10.07h-7.367l7.579-38.001m6.201 6.042-3.18 15.9c0.21198 0.0353 0.42398 0.053 0.636 0.053h0.742c3.392 0.0353 6.2186-0.30033 8.48-1.007 2.2613-0.74199 3.7806-3.3213 4.558-7.738 0.63597-3.71-0.00003-5.8476-1.908-6.413-1.8727-0.56531-4.2224-0.83031-7.049-0.795-0.42402 0.0353-0.83035 0.053-1.219 0.053-0.35335 0.00002-0.72435 0.00002-1.113 0l0.053-0.053"
                    }),
                    /*#__PURE__*/ (0, $gGrEF$jsx)("path", {
                        d: "m133.49 469.36h7.314l-2.067 10.123h6.572c3.604 0.0707 6.2893 0.81269 8.056 2.226 1.802 1.4134 2.332 4.0987 1.59 8.056l-3.551 17.649h-7.42l3.392-16.854c0.35328-1.7666 0.2473-3.021-0.318-3.763-0.56536-0.74198-1.7844-1.113-3.657-1.113l-5.883-0.053-4.346 21.783h-7.314l7.632-38.054"
                    }),
                    /*#__PURE__*/ (0, $gGrEF$jsx)("path", {
                        d: "m162.81 479.48h14.204c4.1693 0.0354 7.1903 1.2367 9.063 3.604 1.8726 2.3674 2.491 5.6004 1.855 9.699-0.24737 1.8727-0.79503 3.71-1.643 5.512-0.8127 1.802-1.9434 3.4273-3.392 4.876-1.7667 1.8373-3.657 3.0033-5.671 3.498-2.014 0.49467-4.0987 0.742-6.254 0.742h-6.36l-2.014 10.07h-7.367l7.579-38.001m6.201 6.042-3.18 15.9c0.21199 0.0353 0.42399 0.053 0.636 0.053h0.742c3.392 0.0353 6.2186-0.30033 8.48-1.007 2.2613-0.74199 3.7806-3.3213 4.558-7.738 0.63597-3.71-0.00003-5.8476-1.908-6.413-1.8727-0.56531-4.2224-0.83031-7.049-0.795-0.42402 0.0353-0.83035 0.053-1.219 0.053-0.35335 0.00002-0.72435 0.00002-1.113 0l0.053-0.053"
                    })
                ]
            })
        })
    });
    if (language === "json") return /*#__PURE__*/ (0, $gGrEF$jsxs)("svg", {
        xmlns: "http://www.w3.org/2000/svg",
        xmlnsXlink: "http://www.w3.org/1999/xlink",
        viewBox: "0 0 160 160",
        children: [
            /*#__PURE__*/ (0, $gGrEF$jsxs)("defs", {
                children: [
                    /*#__PURE__*/ (0, $gGrEF$jsxs)("linearGradient", {
                        id: "a",
                        children: [
                            /*#__PURE__*/ (0, $gGrEF$jsx)("stop", {
                                offset: "0"
                            }),
                            /*#__PURE__*/ (0, $gGrEF$jsx)("stop", {
                                offset: "1",
                                stopColor: "#fff"
                            })
                        ]
                    }),
                    /*#__PURE__*/ (0, $gGrEF$jsx)("linearGradient", {
                        x1: "-553.27",
                        y1: "525.908",
                        x2: "-666.116",
                        y2: "413.045",
                        id: "c",
                        xlinkHref: "#a",
                        gradientUnits: "userSpaceOnUse",
                        gradientTransform: "matrix(.99884 0 0 .9987 689.008 -388.844)"
                    }),
                    /*#__PURE__*/ (0, $gGrEF$jsx)("linearGradient", {
                        x1: "-666.117",
                        y1: "413.045",
                        x2: "-553.27",
                        y2: "525.908",
                        id: "b",
                        xlinkHref: "#a",
                        gradientUnits: "userSpaceOnUse",
                        gradientTransform: "matrix(.99884 0 0 .9987 689.008 -388.844)"
                    })
                ]
            }),
            /*#__PURE__*/ (0, $gGrEF$jsx)("path", {
                d: "M79.865 119.1c35.397 48.255 70.04-13.469 69.988-50.587-.06-43.886-44.54-68.414-70.017-68.414C38.943.1 0 33.895 0 80.135 0 131.531 44.64 160 79.836 160c-7.965-1.147-34.507-6.834-34.863-67.967-.24-41.346 13.487-57.865 34.805-50.599.477.177 23.514 9.265 23.514 38.95 0 29.56-23.427 38.716-23.427 38.716z",
                style: {
                    marker: "none"
                },
                color: "#000",
                fill: "url(#b)",
                fillRule: "evenodd",
                overflow: "visible"
            }),
            /*#__PURE__*/ (0, $gGrEF$jsx)("path", {
                d: "M79.823 41.4C56.433 33.34 27.78 52.618 27.78 91.23c0 63.048 46.72 68.77 52.384 68.77C121.057 160 160 126.204 160 79.964 160 28.568 115.36.1 80.164.1c9.749-1.35 52.541 10.55 52.541 69.037 0 38.141-31.953 58.905-52.735 50.033-.478-.177-23.514-9.264-23.514-38.95 0-29.56 23.367-38.818 23.367-38.818z",
                style: {
                    marker: "none"
                },
                color: "#000",
                fill: "url(#c)",
                fillRule: "evenodd",
                overflow: "visible"
            })
        ]
    });
    return undefined;
}


const $8907530ce2ae75d0$var$Preview = (props)=>{
    return /*#__PURE__*/ (0, $gGrEF$jsx)((0, $0fe3fd43374a598c$export$2e2bcd8739ae039), {
        ...props
    });
};
var $8907530ce2ae75d0$export$2e2bcd8739ae039 = {
    name: "code",
    type: "object",
    title: "Code",
    components: {
        input: (0, $a1d4bfd2763f687f$export$20d4ca75cb144ab0)
    },
    icon: (0, $gGrEF$CodeBlockIcon),
    fields: [
        {
            name: "language",
            title: "Language",
            type: "string"
        },
        {
            name: "filename",
            title: "Filename",
            type: "string"
        },
        {
            title: "Code",
            name: "code",
            type: "text"
        },
        {
            title: "Highlighted lines",
            name: "highlightedLines",
            type: "array",
            of: [
                {
                    type: "number",
                    title: "Highlighted line"
                }, 
            ]
        }, 
    ],
    preview: {
        select: {
            language: "language",
            code: "code",
            filename: "filename",
            highlightedLines: "highlightedLines"
        },
        prepare: (value)=>{
            return {
                title: value.filename || (value.language || "unknown").toUpperCase(),
                media: (0, $a7f1af2d8cb566bf$export$a854ab43349813f2)(value?.language),
                extendedPreview: /*#__PURE__*/ (0, $gGrEF$jsx)($8907530ce2ae75d0$var$Preview, {
                    value: value
                })
            };
        }
    }
};



const $df9eabe9bda49ea8$export$d18430c17c97a000 = (0, $gGrEF$createPlugin)({
    name: "@sanity/code-input",
    schema: {
        types: [
            (0, $8907530ce2ae75d0$export$2e2bcd8739ae039)
        ]
    }
});


export {$df9eabe9bda49ea8$export$d18430c17c97a000 as codeInput, $0fe3fd43374a598c$export$2e2bcd8739ae039 as PreviewCode};
//# sourceMappingURL=index.js.map
