import { ObjectInputProps } from "sanity/form";
import { ObjectSchemaType } from "@sanity/types";
export interface CodeInputLanguage {
    title: string;
    value: string;
    mode?: string;
}
interface CodeInputType {
    name?: string;
    title?: string;
    description?: string;
    fields: {
        name: string;
        title?: string;
        placeholder?: string;
    }[];
    options?: {
        theme?: string;
        languageAlternatives: CodeInputLanguage[];
        language: string;
        withFilename?: boolean;
    };
}
export interface CodeInputValue {
    _type?: 'code';
    code?: string;
    filename?: string;
    language?: string;
    highlightedLines?: number[];
}
export type CodeSchemaType = Omit<ObjectSchemaType, 'options'> & {
    options: {
        theme?: string;
        darkTheme?: string;
        languageAlternatives: CodeInputLanguage[];
        language: string;
        withFilename?: boolean;
    };
};
export type CodeInputProps = ObjectInputProps<CodeInputValue, CodeSchemaType>;
interface PreviewCodeProps {
    type?: CodeInputType;
    value?: CodeInputValue;
}
export function PreviewCode(props: PreviewCodeProps): JSX.Element;
export const codeInput: import("sanity").Plugin<void>;

//# sourceMappingURL=index.d.ts.map
